// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "BountyClass.h"
#include "SideBountyClass.generated.h"

DECLARE_DYNAMIC_MULTICAST_DELEGATE_OneParam(FCompletedSideBounty, int, FavoursEarned);

UCLASS()
class ENDLESSVENDETTA_API ASideBountyClass : public ABountyClass
{
	GENERATED_BODY()
	
protected:
	UPROPERTY(EditDefaultsOnly, Category = "Side Bounty")
	int FavoursEarnedForCompletion = 1;
	
	virtual void BeginPlay() override;

public:
	FCompletedSideBounty CompletedSideBounty;
	
	virtual void IncrementBountyCheckpoint() override;
	void DestroyCheckpoints();
	int GetRewardInFavours()
	{
		return FavoursEarnedForCompletion;
	}
};
